<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="巷道id" prop="srmNumber">
        <el-input v-model="formData.srmNumber" placeholder="请输入巷道id" />
      </el-form-item>
      <el-form-item label="随行工单号" prop="taskId">
        <el-input v-model="formData.taskId" placeholder="请输入随行工单号" />
      </el-form-item>
      <el-form-item label="1：左   2：右" prop="fromDirection">
        <el-input v-model="formData.fromDirection" placeholder="请输入1：左   2：右" />
      </el-form-item>
      <el-form-item label="出列" prop="fromColumn">
        <el-input v-model="formData.fromColumn" placeholder="请输入出列" />
      </el-form-item>
      <el-form-item label="出层" prop="fromRow">
        <el-input v-model="formData.fromRow" placeholder="请输入出层" />
      </el-form-item>
      <el-form-item label="出库内外" prop="fromSeparation">
        <el-input v-model="formData.fromSeparation" placeholder="请输入出库内外" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { OrderApi, OrderVO } from '@/api/logistics/order'

/** 随行记录 表单 */
defineOptions({ name: 'OrderForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  srmNumber: undefined,
  taskId: undefined,
  fromDirection: undefined,
  fromColumn: undefined,
  fromRow: undefined,
  fromSeparation: undefined,
  pics: undefined,
  trayCode: undefined,
  storageCode: undefined,
  toDirection: undefined,
  toColumn: undefined,
  toSeparation: undefined,
  toRow: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await OrderApi.getOrder(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as OrderVO
    if (formType.value === 'create') {
      await OrderApi.createOrder(data)
      message.success(t('common.createSuccess'))
    } else {
      await OrderApi.updateOrder(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    srmNumber: undefined,
    taskId: undefined,
    fromDirection: undefined,
    fromColumn: undefined,
    fromRow: undefined,
    fromSeparation: undefined,
    pics: undefined,
    trayCode: undefined,
    storageCode: undefined,
    toDirection: undefined,
    toColumn: undefined,
    toSeparation: undefined,
    toRow: undefined,
  }
  formRef.value?.resetFields()
}
</script>